
/*****************************************************************************
                         E R I N A - L i b r a r y
                                                      ŏIXV 2001/05/29
 ----------------------------------------------------------------------------
         Copyright (C) 2000-2001 Leshade Entis. All rights reserved.
 *****************************************************************************/


#if	!defined(ERINALIB_H_INCLUDE)
#define	ERINALIB_H_INCLUDE

#include "experi.h"
#include "cmperi.h"
#include "cxmio.h"



/*****************************************************************************
                        ERI t@CC^[tF[X
 *****************************************************************************/

class	ERIFile	: public	EFileObject
{
protected:
	EFileObject *	m_pFile ;
	struct	RECORD_HEADER
	{
		UINT64	ui64ID ;
		UINT64	ui64Length ;
	} ;
	struct	RECORD_INFO
	{
		RECORD_HEADER	header ;
		RECORD_INFO *	pParent ;
		DWORD			dwOffset ;
		DWORD			dwLimit ;
	} ;
	RECORD_INFO *	m_pRecInf ;

public:
	// IuWFNg
	class	EStringObj
	{
	protected:
		char *	m_ptrString ;
		int		m_nLength ;
	public:
		// \z֐
		EStringObj( void ) ;
		EStringObj( const char * pszString ) ;
		EStringObj( const wchar_t * pwszString ) ;
		// Ŋ֐
		~EStringObj( void ) ;
		// Q
		operator const char * ( void ) const
			{	return	m_ptrString ;	}
		const char * CharPtr( void ) const
			{	return	m_ptrString ;	}
		int GetLength( void ) const
			{	return	m_nLength ;		}
		// 
		const EStringObj & operator = ( const EStringObj & string ) ;
	} ;

	// ǂݍ݃}XN
	enum	ReadMask
	{
		rmFileHeader	= 0x00000001,
		rmPreviewInfo	= 0x00000002,
		rmImageInfo		= 0x00000004,
		rmSoundInfo		= 0x00000008,
		rmCopyright		= 0x00000010,
		rmDescription	= 0x00000020,
		rmPaletteTable	= 0x00000040
	} ;
	DWORD			m_fdwReadMask ;
	// t@Cwb_
	ERI_FILE_HEADER	m_FileHeader ;
	// vr[摜wb_
	ERI_INFO_HEADER	m_PreviewInfo ;
	// 摜wb_
	ERI_INFO_HEADER	m_InfoHeader ;
	// wb_
	MIO_INFO_HEADER	m_MIOInfHdr ;
	// pbge[u
	ENTIS_PALETTE	m_PaletteTable[0x100] ;
	// 쌠
	EStringObj		m_strCopyright ;
	// Rg
	EStringObj		m_strDescription ;

public:
	// \z֐
	ERIFile( void ) ;
	// Ŋ֐
	virtual ~ERIFile( void ) ;

	// t@C̃I[v@
	enum	OpenType
	{
		otOpenRoot,			// [gR[hJ
		otReadHeader,		// wb_R[hǂݍŒl
		otOpenStream,		// wb_ǂݍ݃Xg[R[hJ
		otOpenImageData		// 摜f[^R[hJ
	} ;
	// bt@CJ
	bool Open( EFileObject * pFile, OpenType type = otOpenImageData ) ;
	// t@C
	void Close( void ) ;

	// R[hJ
	bool DescendRecord( const UINT64 * pRecID = NULL ) ;
	// R[h
	void AscendRecord( void ) ;
	// R[hID擾
	UINT64 GetRecordID( void ) const ;

	virtual DWORD Read( void * ptrBuf, DWORD dwByte ) ;
	virtual DWORD GetLength( void ) ;
	virtual DWORD GetPointer( void ) ;
	virtual void Seek( DWORD dwPointer ) ;

} ;


/*****************************************************************************
                    MIOt@CXg[ĐIuWFNg
 *****************************************************************************/

class	MIODynamicPlayer
{
public:
	// \z֐
	MIODynamicPlayer( void ) ;
	// Ŋ֐
	~MIODynamicPlayer( void ) ;

protected:
	//
	// R[hǂ݃IuWFNg
	class	EPreloadBuffer	: public	EMemFile
	{
	public:
		BYTE *			m_ptrBuffer ;
		ULONG			m_nKeySample ;
		MIO_DATA_HEADER	m_miodh ;
	public:
		// \z֐
		EPreloadBuffer( DWORD dwLength ) ;
		// Ŋ֐
		virtual ~EPreloadBuffer( void ) ;
	} ;
	//
	// L[t[|Cg\
	struct	KEY_POINT
	{
		ULONG	nKeySample ;
		DWORD	dwRecOffset ;
	} ;
	//
	// EPreloadBuffer zIuWFNg
	class	EPreloadQueue
	{
	public:
		EPreloadBuffer **	m_queue ;
		unsigned int		m_length ;
		unsigned int		m_limit ;
	public:
		// \z֐
		EPreloadQueue( void ) ;
		// Ŋ֐
		~EPreloadQueue( void ) ;
		// z̍ő̒ݒ
		void SetLimit( unsigned int nLimit ) ;
		// z
		void RemoveAll( void ) ;
	} ;
	//
	// KEY_POINT zIuWFNg
	class	EKeyPointList
	{
	public:
		KEY_POINT *		m_list ;
		unsigned int	m_count ;
		unsigned int	m_limit ;
	public:
		// \z֐
		EKeyPointList( void ) ;
		// Ŋ֐
		~EKeyPointList( void ) ;
		// z̍ō܂̒ݒ
		void SetLimit( unsigned int nLimit ) ;
		// z
		void RemoveAll( void ) ;
	} ;
	//
	// XbhpbZ[W
	enum	ThreadMessage
	{
		tmSeekSound	= WM_USER,
		tmQuit
	} ;

	// ERIAj[Vt@C
	ERIFile					m_erif ;
	// WJIuWFNg
	EFileDecodeContext *	m_pmioc ;
	MIODecoder				m_miod ;
	// ǂ݃Xbh
	HANDLE					m_hThread ;
	DWORD					m_idThread ;
	// ǂ݃L[
	EPreloadQueue			m_queueSound ;
	HANDLE					m_hQueueNotEmpty ;	// ǂ݃L[łȂ
	HANDLE					m_hQueueSpace ;		// ǂ݃L[ɓǂݍ݉\
	// V[NpL[|Cgz
	EKeyPointList			m_listKeySample ;
	// rI
	CRITICAL_SECTION		m_cs ;

public:
	// MIO t@CJ
	bool Open( EFileObject * pFile, unsigned int nPreloadSize = 0 ) ;
	// MIO t@C
	void Close( void ) ;

	// wTvֈړA߂̃ubÑf[^擾
	virtual void * GetWaveBufferFrom
		( ULONG nSample, DWORD & dwBytes, DWORD & dwOffsetBytes ) ;
	// ̉f[^Xg[̐擪ł邩H
	virtual bool IsNextDataRewound( void ) ;
	// ̉f[^擾
	virtual void * GetNextWaveBuffer( DWORD & dwBytes ) ;
	// obt@m
	virtual void * AllocateWaveBuffer( DWORD dwBytes ) ;
	// f[^j
	virtual void DeleteWaveBuffer( void * ptrWaveBuf ) ;

public:
	// `l擾
	DWORD GetChannelCount( void ) const ;
	// TvOg擾
	DWORD GetFrequency( void ) const ;
	// TvOrbg\擾
	DWORD GetBitsPerSample( void ) const ;
	// Ŝ̒iTvj擾
	DWORD GetTotalSampleCount( void ) const ;

protected:
	// ǂ݃obt@擾
	EPreloadBuffer * GetPreloadBuffer( void ) ;
	// ǂ݃obt@ɒǉ
	void AddPreloadBuffer( EPreloadBuffer * pBuffer ) ;

protected:
	// Xbh֐
	static DWORD WINAPI ThreadProc( LPVOID parameter ) ;
	DWORD LoadingThreadProc( void ) ;
	// L[t[|Cgǉ
	void AddKeySample( KEY_POINT key ) ;
	// w̃L[t[
	KEY_POINT * SearchKeySample( unsigned int nKeySample ) ;
	// w̃Tv܂ރubNǂݍ
	void SeekKeySample( ULONG nSample, unsigned int & nCurrentSample ) ;

public:
	// riNeBJZNVj
	void Lock( void ) ;
	void Unlock( void ) ;

} ;


/*****************************************************************************
                    ERIAj[Vt@CIuWFNg
 *****************************************************************************/

class	ERIAnimation
{
public:
	// \z֐
	ERIAnimation( void ) ;
	// Ŋ֐
	~ERIAnimation( void ) ;

protected:
	//
	// R[hǂ݃IuWFNg
	class	EPreloadBuffer	: public	EMemFile
	{
	public:
		BYTE *	m_ptrBuffer ;
		ULONG	m_iFrameIndex ;
		UINT64	m_ui64RecType ;
	public:
		// \z֐
		EPreloadBuffer( DWORD dwLength ) ;
		// Ŋ֐
		virtual ~EPreloadBuffer( void ) ;
	} ;
	//
	// L[t[|Cg\
	struct	KEY_POINT
	{
		ULONG	iKeyFrame ;
		DWORD	dwRecOffset ;
	} ;
	//
	// EPreloadBuffer zIuWFNg
	class	EPreloadQueue
	{
	public:
		EPreloadBuffer **	m_queue ;
		unsigned int		m_length ;
		unsigned int		m_limit ;
	public:
		// \z֐
		EPreloadQueue( void ) ;
		// Ŋ֐
		~EPreloadQueue( void ) ;
		// z̍ő̒ݒ
		void SetLimit( unsigned int nLimit ) ;
		// z
		void RemoveAll( void ) ;
	} ;
	//
	// KEY_POINT zIuWFNg
	class	EKeyPointList
	{
	public:
		KEY_POINT *		m_list ;
		unsigned int	m_count ;
		unsigned int	m_limit ;
	public:
		// \z֐
		EKeyPointList( void ) ;
		// Ŋ֐
		~EKeyPointList( void ) ;
		// z̍ō܂̒ݒ
		void SetLimit( unsigned int nLimit ) ;
		// z
		void RemoveAll( void ) ;
	} ;
	//
	// XbhpbZ[W
	enum	ThreadMessage
	{
		tmSeekFrame	= WM_USER,
		tmSeekSound,
		tmQuit
	} ;

	// ERIAj[Vt@C
	bool					m_fTopDown ;
	bool					m_fWaveOutput ;
	bool					m_fWaveStreaming ;
	ERIFile					m_erif ;
	// WJIuWFNg
	EFileDecodeContext *	m_peric ;
	ERIDecoder				m_erid ;
	EFileDecodeContext *	m_pmioc ;
	MIODecoder				m_miod ;
	// 摜obt@
	unsigned int			m_iCurrentFrame ;
	RASTER_IMAGE_INFO *		m_pDstImage ;
	ENTIS_PALETTE *			m_pPaletteTable ;
	RASTER_IMAGE_INFO *		m_pWorkImage ;
	// ǂ݃Xbh
	HANDLE					m_hThread ;
	DWORD					m_idThread ;
	// 摜ǂ݃L[
	EPreloadQueue			m_queueImage ;
	HANDLE					m_hQueueNotEmpty ;	// ǂ݃L[łȂ
	HANDLE					m_hQueueSpace ;		// ǂ݃L[ɓǂݍ݉\
	// t[V[NpL[t[|Cgz
	EKeyPointList			m_listKeyFrame ;
	EKeyPointList			m_listKeyWave ;
	// rI
	CRITICAL_SECTION		m_cs ;

protected:
	// 摜WJo̓obt@v
	virtual RASTER_IMAGE_INFO * CreateImageBuffer
		( DWORD format, SDWORD width, SDWORD height,
					DWORD bpp, ENTIS_PALETTE ** ppaltbl ) ;
	// 摜WJo̓obt@
	virtual void DeleteImageBuffer
		( RASTER_IMAGE_INFO * prii, ENTIS_PALETTE * paltbl ) ;
	// o͗v
	virtual bool RequestWaveOut
		( DWORD channels, DWORD frequency, DWORD bps ) ;
	// o͏I
	virtual void CloseWaveOut( void ) ;
	// f[^o
	virtual void PushWaveBuffer( void * ptrWaveBuf, DWORD dwBytes ) ;
	// obt@m
	virtual void * AllocateWaveBuffer( DWORD dwBytes ) ;
	// f[^j
	virtual void DeleteWaveBuffer( void * ptrWaveBuf ) ;
public:
	// Xg[~OJn
	virtual void BeginWaveStreaming( void ) ;
	// Xg[~OI
	virtual void EndWaveStreaming( void ) ;

public:
	// Aj[Vt@CJ
	bool Open( EFileObject * pFile,
			unsigned int nPreloadSize = 0, bool fTopDown = false ) ;
	// Aj[Vt@C
	void Close( void ) ;

	// 擪t[ֈړ
	bool SeekToBegin( void ) ;
	// ̃t[ֈړ
	bool SeekToNextFrame( int nSkipFrame = 0 ) ;
	// w̃t[Ɉړ
	bool SeekToFrame( unsigned int iFrameIndex ) ;
	// w̃t[̓L[t[H
	bool IsKeyFrame( unsigned int iFrameIndex ) ;

protected:
	// ̃t[WJ
	bool DecodeNextFrame( void ) ;
	// ǂ݃obt@擾
	EPreloadBuffer * GetPreloadBuffer( void ) ;
	// ǂ݃obt@ɒǉ
	void AddPreloadBuffer( EPreloadBuffer * pBuffer ) ;

public:
	// Jgt[̃CfbNX擾
	unsigned int CurrentIndex( void ) const ;
	// Jgt[̉摜擾
	const RASTER_IMAGE_INFO * GetImageInfo( void ) const ;
	// pbge[u擾
	const ENTIS_PALETTE * GetPaletteEntries( void ) const ;
	// L[t[擾
	unsigned int GetKeyFrameCount( void ) const ;
	// St[擾
	unsigned int GetAllFrameCount( void ) const ;
	// SAj[VԂ擾
	unsigned int GetTotalTime( void ) const ;
	// t[ԍ玞Ԃ֕ϊ
	unsigned int FrameIndexToTime( unsigned int iFrameIndex ) const ;
	// Ԃt[ԍ֕ϊ
	unsigned int TimeToFrameIndex( unsigned int nMilliSec ) const ;

protected:
	// Xbh֐
	static DWORD WINAPI ThreadProc( LPVOID parameter ) ;
	DWORD LoadingThreadProc( void ) ;
	// L[t[|Cgǉ
	void AddKeyPoint( EKeyPointList & list, KEY_POINT key ) ;
	// w̃L[t[
	KEY_POINT * SearchKeyPoint
		( EKeyPointList & list, unsigned int iKeyFrame ) ;
	// w̃t[ɃV[N
	void SeekKeyPoint
		( EKeyPointList & list,
			unsigned int iFrame, unsigned int & iCurtrentFrame ) ;
	// w̉f[^܂ŃV[NăXg[~Oo͂
	void SeekKeyWave
		( EKeyPointList & list, unsigned int iFrame ) ;

public:
	// riNeBJZNVj
	void Lock( void ) ;
	void Unlock( void ) ;

} ;


/*****************************************************************************
                  ERIAj[Vt@Co̓IuWFNg
 *****************************************************************************/

class	ERIAnimationWriter
{
public:
	// \z֐
	ERIAnimationWriter( void ) ;
	// Ŋ֐
	~ERIAnimationWriter( void ) ;

protected:
	//
	// o̓obt@IuWFNg
	class	EOutputBuffer
	{
	public:
		EOutputBuffer *	m_ptrNext ;
		DWORD			m_dwBytes ;
		PVOID			m_ptrBuffer ;
	public:
		// \z֐
		EOutputBuffer( const BYTE * ptrBuffer, ULONG nBytes ) ;
		// Ŋ֐
		~EOutputBuffer( void ) ;
	} ;
	//
	// kReLXg
	class	EEncodeContext	: public	RLHEncodeContext
	{
	public:
		EOutputBuffer *	m_pFirstBuf ;
		EOutputBuffer *	m_pLastBuf ;
		DWORD			m_dwTotalBytes ;
	public:
		// \z֐
		EEncodeContext( void ) ;
		// Ŋ֐
		virtual ~EEncodeContext( void ) ;
		// f[^
		void Delete( void ) ;
		// ̃f[^o
		virtual ULONG WriteNextData( const BYTE * ptrBuffer, ULONG nBytes ) ;
	} ;
	//
	// XbhbZ[W
	enum	ThreadMessage
	{
		tmEncodeImage	= WM_USER,
		tmQuit
	} ;

	// oXe[^X
	enum	WriterStatus
	{
		wsNotOpened,
		wsOpened,
		wsWritingHeader,
		wsWritingStream
	} ;
	WriterStatus			m_wsStatus ;		// Xe[^X
	// t@CIuWFNg
	ERIWriteFile			m_eriwf ;			// t@CIuWFNg
	// wb_
	DWORD					m_dwHeaderBytes ;	// wb_R[h̃oCg
	ERI_FILE_HEADER			m_efh ;				// t@Cwb_
	ERI_INFO_HEADER			m_prvwih ;			// vr[摜wb_
	ERI_INFO_HEADER			m_eih ;				// 摜wb_
	MIO_INFO_HEADER			m_mih ;				// wb_
	// t[ԍ
	DWORD					m_dwKeyFrame ;		// L[t[
	DWORD					m_dwKeyWave ;		// L[EF[u
	DWORD					m_dwFrameCount ;	// o͍ς݃t[
	DWORD					m_dwWaveCount ;		// o͍ς݃EF[u
	// o͏
	DWORD					m_dwMioHeaderPos ;		// wb_̈ʒu
	DWORD					m_dwOutputWaveSamples ;	// o͍ς݃Tv
	// kIuWFNg
	EEncodeContext			m_eric1 ;
	EEncodeContext			m_eric2 ;
	ERIEncoder				m_erie1 ;
	ERIEncoder				m_erie2 ;
	EFileEncodeContext *	m_pmioc ;
	MIOEncoder				m_mioe ;
	// pobt@
	RASTER_IMAGE_INFO *		m_priiLast ;
	RASTER_IMAGE_INFO *		m_priiBuf ;
	// 摜kXbh
	bool					m_fDualEncoding ;
	bool					m_fCompressSuccessed ;
	HANDLE					m_hCompressed ;
	HANDLE					m_hThread ;
	DWORD					m_idThread ;
	// 摜̈kp[^
	ERIEncoder::PARAMETER	m_eriep ;
	// ̈kp[^
	double					m_rLowWeight ;
	double					m_rMiddleWeight ;
	double					m_rPowerScale ;
	int						m_nOddWeight ;

public:
	// t@CJ
	bool Open( EWriteFileObj * pFile, ERIWriteFile::FileID fidType ) ;
	// t@C
	void Close( void ) ;

public:
	// t@Cwb_J
	bool BeginFileHeader( DWORD dwKeyFrame, DWORD dwKeyWave ) ;
	// vr[摜wb_o
	bool WritePreviewInfo( const ERI_INFO_HEADER & eih ) ;
	// 摜wb_o
	bool WriteEriInfoHeader( const ERI_INFO_HEADER & eih ) ;
	// wb_o
	bool WriteMioInfoHeader( const MIO_INFO_HEADER & mih ) ;
	// 쌠o
	bool WriteCopyright( const void * ptrCopyright, DWORD dwBytes ) ;
	// Rgo
	bool WriteDescription( const void * ptrDescription, DWORD dwBytes ) ;
	// t@Cwb_
	void EndFileHeader( void ) ;

public:
	// 摜̈kp[^ݒ肷
	void SetImageCompressionParameter
			( const ERIEncoder::PARAMETER & eriep ) ;
	// ̈kp[^ݒ肷
	void SetSoundCompressionParameter
		( double rLowWeight = 16.0,
			double rMiddleWeight = 8.0,
			double rPowerScale = 0.5,
			int nOddWeight = 1 ) ;

public:
	// Xg[Jn
	bool BeginStream( void ) ;
	// pbge[uo
	bool WritePaletteTable
		( const ENTIS_PALETTE * paltbl, unsigned int nLength ) ;
	// vr[摜o͂
	bool WritePreviewData( const RASTER_IMAGE_INFO & rii, DWORD fdwFlags ) ;
	// f[^o͂
	bool WriteWaveData( const void * ptrWaveBuf, DWORD dwSampleCount ) ;
	// 摜f[^o͂
	bool WriteImageData( const RASTER_IMAGE_INFO & rii, DWORD fdwFlags ) ;
	// Xg[
	bool EndStream( DWORD dwTotalTime ) ;

protected:
	// 摜obt@𐶐
	RASTER_IMAGE_INFO * CreateImageBuffer( const ERI_INFO_HEADER & eih ) ;
	// 摜obt@
	void DeleteImageBuffer( RASTER_IMAGE_INFO * prii ) ;

public:
	// o͂ꂽ摜̖擾
	DWORD GetWrittenFrameCount( void ) const ;
	// }`XbhkL
	void EnableDualEncoding( bool fDualEncoding ) ;

protected:
	// Xbh֐
	static DWORD WINAPI ThreadProc( LPVOID parameter ) ;
	DWORD EncodingThreadProc( void ) ;

} ;


#endif
